#! /usr/bin/python
# -*- coding: iso-8859-1 -*-
#
#
# com.py
#
# Copyright (C) 2010,2011
# Lorenzo Carbonell Cerezo <lorenzo.carbonell.cerezo@gmail.com>
# Miguel Angel Santamaría Rogado <leibag@gmail.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#

import os
import sys
import locale
import gettext
######################################

def is_package():
	return __file__.find('src') < 0

######################################


PARAMS = {	'viewer':{ 'value':'','default':'browser'}
			}

VERSION = '0.0.4.0'
APPNAME = 'Scope-YouTube'
APP = 'scope-youtube'
APP_CONF = APP + '.conf'
CONFIG_DIR = os.path.join(os.path.expanduser('~'),'.config')
CONFIG_APP_DIR = os.path.join(CONFIG_DIR, APP)
CONFIG_FILE = os.path.join(CONFIG_APP_DIR, APP_CONF)

# check if running from source
if is_package():
	ROOTDIR = '/usr/share/'
	LANGDIR = os.path.join(ROOTDIR, 'locale-langpack')
	APPDIR = os.path.join(ROOTDIR, APP)
	ICON = '/usr/share/unity/lenses/yavol/yavol-youtube.svg'
else:
	VERSION = VERSION + '-src'
	ROOTDIR = os.path.dirname(__file__)
	LANGDIR = os.path.normpath(os.path.join(ROOTDIR, '../template1'))
	APPDIR = ROOTDIR
	IMGDIR = os.path.normpath(os.path.join(ROOTDIR, '../data'))
	ICON = os.path.join(IMGDIR, 'yavol-youtube.svg')
KEY = 'apps.scopes.scope-youtube'

try:
	current_locale, encoding = locale.getdefaultlocale()
	language = gettext.translation(APP, LANGDIR, [current_locale])
	language.install()
	print(language)
	if sys.version_info[0] == 3:
		_ = language.gettext
	else:
		_ = language.ugettext
except Exception as e:
	print(e)
	_ = str
