#! /usr/bin/python
# -*- coding: utf-8 -*-
#
# preferences.py
#
# Copyright (C) 2012
# Lorenzo Carbonell Cerezo <lorenzo.carbonell.cerezo@gmail.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import os
import comun
import shutil
from gi.repository import Gio
from configurator import Configuration


YVIEWER = ['yviewer','/usr/bin/yviewer','/usr/bin/yviewer "%s"']
VLC = ['vlc','/usr/bin/vlc','/usr/bin/vlc --one-instance "%s"']
MINITUBE = ['minitube','/usr/bin/minitube','/usr/bin/minitube "%s"']
SMPLAYER = ['smplayer','/usr/bin/smplayer','/usr/bin/smplayer "%s"']
TOTEM = ['totem','/usr/bin/totem','/usr/bin/totem "%s"']
MIRO = ['miro','/usr/bin/miro','/usr/bin/miro "%s"']
DOWNLOAD = ['youtube-dl','/usr/bin/youtube-dl','/usr/share/yavol-scope-youtube/downloader.py "%s"']
BROWSER = ['browser','browser','"%s"']
SELECTPLAYER = ['selectplayer','selectplayer','/usr/share/yavol-scope-youtube/selectplayer.py "%s"']

class Preferences():
	def __init__(self):
		self.vlc = Gio.File.new_for_path(VLC[1])
		self.minitube = Gio.File.new_for_path(MINITUBE[1])
		self.smplayer = Gio.File.new_for_path(SMPLAYER[1])
		self.yviewer = Gio.File.new_for_path(YVIEWER[1])
		self.totem = Gio.File.new_for_path(TOTEM[1])
		self.miro = Gio.File.new_for_path(MIRO[1])
		self.download = Gio.File.new_for_path(DOWNLOAD[1])
		self.configurator = Configuration()
		self.get_active_viewer()
			
	def save(self):
		self.configurator.set('viewer',self.viewer)
		self.configurator.save()
	
	def get_active_viewer(self):
		self.configurator.read()
		self.viewer = self.configurator.get('viewer')
		if self.viewer == 'yviewer':
			if self.yviewer.query_exists(None):
				return YVIEWER
			else:
				return BROWSER
		elif self.viewer == 'vlc':
			if self.vlc.query_exists(None):
				return VLC
			else:
				return BROWSER
		elif self.viewer == 'minitube':
			if self.minitube.query_exists(None):
				return MINITUBE
			else:
				return BROWSER
		elif self.viewer == 'smplayer':
			if self.smplayer.query_exists(None):
				return SMPLAYER
			else:
				return BROWSER
		elif self.viewer == 'totem':
			if self.totem.query_exists(None):
				return TOTEM
			else:
				return BROWSER
		elif self.viewer == 'miro':
			if self.miro.query_exists(None):
				return MIRO
			else:
				return BROWSER
		elif self.viewer == 'download':
			if self.download.query_exists(None):
				return DOWNLOAD
			else:
				return BROWSER
		elif self.viewer == 'selectplayer':
			return SELECTPLAYER
		return BROWSER

		
	def set_default(self):
		self.viewer = 'browser'
		self.save()
		
if __name__ == "__main__":
	pf = Preferences()
	pf.save()
	print pf.viewer
	exit(0)
