#! /usr/bin/python
# -*- coding: utf-8 -*-
#
# preferences_dialog.py
#
# Copyright (C) 2011,2012
# Lorenzo Carbonell Cerezo <lorenzo.carbonell.cerezo@gmail.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import gi
gi.require_version('Gtk', '3.0')
from gi.repository import Gtk
from gi.repository import Gdk
from gi.repository import Gio
import preferences
import comun
from comun import _

class PreferencesDialog(Gtk.Dialog):

	def __init__(self):
		#
		self.preferences = preferences.Preferences()
		Gtk.Dialog.__init__(self, 'Scope-Youtube | '+_('Preferences'),None,Gtk.DialogFlags.MODAL | Gtk.DialogFlags.DESTROY_WITH_PARENT,(Gtk.STOCK_CANCEL, Gtk.ResponseType.REJECT,Gtk.STOCK_OK, Gtk.ResponseType.ACCEPT))
		self.set_position(Gtk.WindowPosition.CENTER_ALWAYS)
		self.set_size_request(400, 130)
		self.connect('close', self.close_application)
		self.set_icon_from_file(comun.ICON)
		#
		self.vbox1 = Gtk.VBox(spacing = 5)
		self.vbox1.set_border_width(5)
		self.get_content_area().add(self.vbox1)
		#
		self.frame1 = Gtk.Frame()
		self.vbox1.add(self.frame1)
		#***************************************************************
		self.vbox2 = Gtk.VBox(spacing = 5)
		self.vbox2.set_border_width(5)
		self.frame1.add(self.vbox2)
		table1 = Gtk.Table(10,2,True)
		self.vbox2.add(table1)
		#
		label1 = Gtk.Label.new(_('Select viewer')+':')
		label1.set_alignment(0,0.5)
		table1.attach(label1,0,1,0,1)
		self.radiobutton0 = Gtk.RadioButton.new_with_label_from_widget(None,_('Browser'))
		table1.attach(self.radiobutton0,0,1,1,2)
		self.radiobutton1 = Gtk.RadioButton.new_with_label_from_widget(self.radiobutton0,_('Download'))
		table1.attach(self.radiobutton1,0,1,2,3)
		self.radiobutton2 = Gtk.RadioButton.new_with_label_from_widget(self.radiobutton0,_('Select Player'))
		table1.attach(self.radiobutton2,0,1,3,4)
		self.radiobutton3 = Gtk.RadioButton.new_with_label_from_widget(self.radiobutton0,_('yviewer'))
		table1.attach(self.radiobutton3,0,1,4,5)
		self.radiobutton4 = Gtk.RadioButton.new_with_label_from_widget(self.radiobutton0,_('Totem'))
		table1.attach(self.radiobutton4,0,1,5,6)
		self.radiobutton5 = Gtk.RadioButton.new_with_label_from_widget(self.radiobutton0,_('Vlc'))
		table1.attach(self.radiobutton5,0,1,6,7)
		self.radiobutton6 = Gtk.RadioButton.new_with_label_from_widget(self.radiobutton0,_('Minitube'))
		table1.attach(self.radiobutton6,0,1,7,8)
		self.radiobutton7 = Gtk.RadioButton.new_with_label_from_widget(self.radiobutton0,_('Smplayer'))
		table1.attach(self.radiobutton7,0,1,8,9)
		self.radiobutton8 = Gtk.RadioButton.new_with_label_from_widget(self.radiobutton0,_('Miro'))
		table1.attach(self.radiobutton8,0,1,9,10)
		#***************************************************************
		#
		download = Gio.File.new_for_path(preferences.DOWNLOAD[1])
		yviewer = Gio.File.new_for_path(preferences.YVIEWER[1])
		totem = Gio.File.new_for_path(preferences.TOTEM[1])
		vlc = Gio.File.new_for_path(preferences.VLC[1])
		minitube = Gio.File.new_for_path(preferences.MINITUBE[1])
		smplayer = Gio.File.new_for_path(preferences.SMPLAYER[1])
		miro = Gio.File.new_for_path(preferences.MIRO[1])
		if not download.query_exists(None):
			self.radiobutton1.set_sensitive(False)
		if not yviewer.query_exists(None):
			self.radiobutton3.set_sensitive(False)
		if not totem.query_exists(None):
			self.radiobutton4.set_sensitive(False)
		if not vlc.query_exists(None):
			self.radiobutton5.set_sensitive(False)
		if not minitube.query_exists(None):
			self.radiobutton6.set_sensitive(False)
		if not smplayer.query_exists(None):
			self.radiobutton7.set_sensitive(False)
		if not miro.query_exists(None):
			self.radiobutton8.set_sensitive(False)
		#
		self.load_preferences()

		#
		self.show_all()
		#
		#
		#
		
	def close_application(self, widget, event):
		self.destroy()
	
	def messagedialog(self,title,message):
		dialog = Gtk.MessageDialog(None,Gtk.DialogFlags.MODAL,Gtk.MessageType.INFO,buttons=Gtk.ButtonsType.OK)
		dialog.set_markup("<b>%s</b>" % title)
		dialog.format_secondary_markup(message)
		dialog.run()
		dialog.destroy()
		
	def load_preferences(self):
		if self.preferences.viewer == 'browser':
			self.radiobutton0.set_active(True)
		elif self.preferences.viewer == 'download':
			if self.radiobutton1.is_sensitive():
				self.radiobutton1.set_active(True)
			else:
				self.radiobutton0.set_active(True)
		elif self.preferences.viewer == 'selectplayer':
			self.radiobutton2.set_active(True)
		elif self.preferences.viewer == 'yviewer':
			if self.radiobutton3.is_sensitive():
				self.radiobutton3.set_active(True)
			else:
				self.radiobutton0.set_active(True)
		elif self.preferences.viewer == 'totem':
			if self.radiobutton4.is_sensitive():
				self.radiobutton4.set_active(True)
			else:
				self.radiobutton0.set_active(True)
		elif self.preferences.viewer == 'vlc':
			if self.radiobutton5.is_sensitive():
				self.radiobutton5.set_active(True)
			else:
				self.radiobutton0.set_active(True)
		elif self.preferences.viewer == 'minitube':
			if self.radiobutton6.is_sensitive():
				self.radiobutton6.set_active(True)
			else:
				self.radiobutton0.set_active(True)
		elif self.preferences.viewer == 'smplayer':
			if self.radiobutton7.is_sensitive():
				self.radiobutton7.set_active(True)
			else:
				self.radiobutton0.set_active(True)
		elif self.preferences.viewer == 'miro':
			if self.radiobutton8.is_sensitive():
				self.radiobutton8.set_active(True)
			else:
				self.radiobutton0.set_active(True)

	def save_preferences(self):
		if self.radiobutton0.get_active() == True:
			viewer = 'browser'
		elif self.radiobutton1.get_active() == True:
			viewer = 'download'
		elif self.radiobutton2.get_active() == True:
			viewer = 'selectplayer'
		elif self.radiobutton3.get_active() == True:
			viewer = 'yviewer'
		elif self.radiobutton4.get_active() == True:
			viewer = 'totem'
		elif self.radiobutton5.get_active() == True:
			viewer = 'vlc'
		elif self.radiobutton6.get_active() == True:
			viewer = 'minitube'
		elif self.radiobutton7.get_active() == True:
			viewer = 'smplayer'
		elif self.radiobutton8.get_active() == True:
			viewer = 'miro'
		self.preferences.viewer = viewer
		self.preferences.save()
		
if __name__ == "__main__":
	cm = PreferencesDialog()
	if 	cm.run() == Gtk.ResponseType.ACCEPT:
		cm.save_preferences()
	cm.hide()
	cm.destroy()
	exit(0)
