#! /usr/bin/python
# -*- coding: utf-8 -*-
#
# downloader.py
#
# Copyright (C) 2011,2012
# Lorenzo Carbonell Cerezo <lorenzo.carbonell.cerezo@gmail.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import gi
gi.require_version('Gtk', '3.0')
from gi.repository import Gtk
from gi.repository import Gio
import sys
import shlex
import subprocess
import os
import comun
import preferences
import webbrowser

from comun import _

def get_formats(url):
	command = '/usr/bin/youtube-dl -F "%s"'%(url)
	result = run(command)
	formats = []
	if result.find('Available formats:')>-1:
		ini = result.find('Available formats:')+19
		sol = result[ini:].replace('\t','')
		for el in sol.split('\n'):
			if el.find(':')>-1:
				formats.append(el.split(':'))
	return formats

def run(command):
	args = shlex.split(command)
	p = subprocess.Popen(args, bufsize=10000, stdout=subprocess.PIPE)
	valor = p.communicate()[0]
	return valor

class SelectPlayer(Gtk.Dialog):

	def __init__(self,url):
		#
		Gtk.Dialog.__init__(self, 'Scope-Youtube | '+_('Download'),None,Gtk.DialogFlags.MODAL | Gtk.DialogFlags.DESTROY_WITH_PARENT,(Gtk.STOCK_CANCEL, Gtk.ResponseType.REJECT,Gtk.STOCK_OK, Gtk.ResponseType.ACCEPT))
		self.set_position(Gtk.WindowPosition.CENTER_ALWAYS)
		self.set_size_request(500, 140)
		self.connect('close', self.close_application)
		self.set_icon_from_file(comun.ICON)
		#
		self.vbox1 = Gtk.VBox(spacing = 5)
		self.vbox1.set_border_width(5)
		self.get_content_area().add(self.vbox1)
		#
		self.frame1 = Gtk.Frame()
		self.vbox1.add(self.frame1)
		#***************************************************************
		self.vbox2 = Gtk.VBox(spacing = 5)
		self.vbox2.set_border_width(5)
		self.frame1.add(self.vbox2)
		table1 = Gtk.Table(9,2,True)
		self.vbox2.add(table1)
		#
		label1 = Gtk.Label.new(_('Select viewer')+':')
		label1.set_alignment(0,0.5)
		table1.attach(label1,0,1,0,1)
		self.radiobutton0 = Gtk.RadioButton.new_with_label_from_widget(None,_('Browser'))
		table1.attach(self.radiobutton0,0,1,1,2)
		self.radiobutton1 = Gtk.RadioButton.new_with_label_from_widget(self.radiobutton0,_('Download'))
		self.radiobutton1.connect('clicked',self.on_radiobutton1_clicked)
		table1.attach(self.radiobutton1,0,1,2,3)
		self.radiobutton2 = Gtk.RadioButton.new_with_label_from_widget(self.radiobutton0,_('yviewer'))
		table1.attach(self.radiobutton2,0,1,3,4)
		self.radiobutton3 = Gtk.RadioButton.new_with_label_from_widget(self.radiobutton0,_('Totem'))
		table1.attach(self.radiobutton3,0,1,4,5)
		self.radiobutton4 = Gtk.RadioButton.new_with_label_from_widget(self.radiobutton0,_('Vlc'))
		table1.attach(self.radiobutton4,0,1,5,6)
		self.radiobutton5 = Gtk.RadioButton.new_with_label_from_widget(self.radiobutton0,_('Minitube'))
		table1.attach(self.radiobutton5,0,1,6,7)
		self.radiobutton6 = Gtk.RadioButton.new_with_label_from_widget(self.radiobutton0,_('Smplayer'))
		table1.attach(self.radiobutton6,0,1,7,8)
		self.radiobutton7 = Gtk.RadioButton.new_with_label_from_widget(self.radiobutton0,_('Miro'))
		table1.attach(self.radiobutton7,0,1,8,9)
		#***************************************************************
		#
		download = Gio.File.new_for_path(preferences.DOWNLOAD[1])
		totem = Gio.File.new_for_path(preferences.TOTEM[1])
		vlc = Gio.File.new_for_path(preferences.VLC[1])
		minitube = Gio.File.new_for_path(preferences.MINITUBE[1])
		smplayer = Gio.File.new_for_path(preferences.SMPLAYER[1])
		yviewer = Gio.File.new_for_path(preferences.YVIEWER[1])
		miro = Gio.File.new_for_path(preferences.MIRO[1])
		if not download.query_exists(None):
			self.radiobutton1.set_sensitive(False)
		if not yviewer.query_exists(None):
			self.radiobutton2.set_sensitive(False)		
		if not totem.query_exists(None):
			self.radiobutton3.set_sensitive(False)
		if not vlc.query_exists(None):
			self.radiobutton4.set_sensitive(False)
		if not minitube.query_exists(None):
			self.radiobutton5.set_sensitive(False)
		if not smplayer.query_exists(None):
			self.radiobutton6.set_sensitive(False)
		if not miro.query_exists(None):
			self.radiobutton7.set_sensitive(False)
		#
		self.frame2 = Gtk.Frame()
		self.vbox1.add(self.frame2)
		#***************************************************************
		self.vbox3 = Gtk.VBox(spacing = 5)
		self.vbox3.set_border_width(5)
		self.frame2.add(self.vbox3)

		table2 = Gtk.Table(2,2,True)
		table2.set_homogeneous(False)
		self.vbox3.add(table2)
		#
		label1 = Gtk.Label.new(_('Select format')+':')		
		label1.set_alignment(0,0.5)
		table2.attach(label1,0,1,0,1, xoptions = Gtk.AttachOptions.SHRINK, yoptions = Gtk.AttachOptions.SHRINK)		
		liststore = Gtk.ListStore(str, str)
		for aformat in get_formats(url):
			liststore.append([aformat[1],aformat[0]])
		self.entry1 = Gtk.ComboBox.new_with_model(model=liststore)
		renderer_text = Gtk.CellRendererText()
		self.entry1.pack_start(renderer_text, True)
		self.entry1.add_attribute(renderer_text, "text", 0)
		self.entry1.set_active(0)
		table2.attach(self.entry1,1,2,0,1, xoptions = Gtk.AttachOptions.FILL, yoptions = Gtk.AttachOptions.SHRINK)		
		#
		button2 =Gtk.Button(_('Select File'))
		button2.connect('clicked',self.on_button_clicked)
		table2.attach(button2,0,1,1,2, xoptions = Gtk.AttachOptions.SHRINK, yoptions = Gtk.AttachOptions.SHRINK)
		#
		self.entry2 = Gtk.Entry()
		self.entry2.set_editable(False)
		self.entry2.set_width_chars(50)
		filename = os.path.join(os.path.expanduser('~'),url.split('v=')[1])
		filename = filename.split('&')[0]
		self.entry2.set_text(filename)
		table2.attach(self.entry2,1,2,1,2, xoptions = Gtk.AttachOptions.FILL, yoptions = Gtk.AttachOptions.SHRINK)		
		#***************************************************************
		self.radiobutton0.set_active(True)
		self.frame2.set_sensitive(False)
		#
		self.show_all()
		#
	def on_radiobutton1_clicked(self,widget):
		self.frame2.set_sensitive(self.radiobutton1.get_active())
	
	def on_button_clicked(self, widget):
		chooser = Gtk.FileChooserDialog(title=('Select where to download the album'),\
										parent=None,action=Gtk.FileChooserAction.SAVE,\
										buttons=(Gtk.STOCK_CANCEL,Gtk.ResponseType.CANCEL,\
										Gtk.STOCK_OPEN,Gtk.ResponseType.OK))
		chooser.set_filename(self.entry2.get_text())
		if chooser.run() == Gtk.ResponseType.OK:
			filename=chooser.get_filename()
			self.entry2.set_text(filename)
		chooser.destroy()

	def close_application(self, widget, event):
		self.hide()

if __name__ == '__main__':
	command = None
	if len(sys.argv)>1:
		url = sys.argv[1]		
	else:
		url = 'http://www.youtube.com/watch?v=oVRpfFYRvW4'
	cm = SelectPlayer(url)
	if 	cm.run() == Gtk.ResponseType.ACCEPT:
		if cm.radiobutton1.get_active():
			tree_iter = cm.entry1.get_active_iter()
			if tree_iter != None:
				model = cm.entry1.get_model()
				dextension = model[tree_iter][0].split('[')[0]
				dformat = model[tree_iter][1]
				filename = cm.entry2.get_text()+'.'+dextension
				command = '/usr/bin/youtube-dl "%s" -f %s -o "%s"'%(url,dformat,filename)
		elif cm.radiobutton2.get_active():
			command = preferences.YVIEWER[2]%(url)
		elif cm.radiobutton3.get_active():
			command = preferences.TOTEM[2]%(url)
		elif cm.radiobutton4.get_active():
			command = preferences.VLC[2]%(url)
		elif cm.radiobutton5.get_active():
			command = preferences.MINITUBE[2]%(url)
		elif cm.radiobutton6.get_active():
			command = preferences.SMPLAYER[2]%(url)
		elif cm.radiobutton7.get_active():
			command = preferences.MIRO[2]%(url)
	cm.hide()
	cm.destroy()
	if command:
		print run(command)
	else:
		webbrowser.open(url)
	exit(0)
